/*
  This file is part of dolt.

  dolt is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  dolt is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with dolt; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  $Id: postscript.h,v 1.4 2003/05/13 18:59:51 beevek Exp $
*/

#ifndef _POSTSCRIPT_H
#define _POSTSCRIPT_H

/*
  Methods for initializing and ending writing of
  image data to a postscript file (drawableObjects
  handle the actual rendering)
*/

#include <fstream>
#include <iomanip> // for precision-setting
#include <dolt-lite/graphics.h>
#include <dolt-lite/geometry.h>

// using namespace std;

namespace dolt {

class psFile : public std::ofstream
{
public:
  psFile() {}
  psFile( const char *file );
  ~psFile();

  bool open( const char *file );

  static Point mapPoint( const Graphics &g, const Bbox &bounds,
    const double &scale, const Point &p );
  static inline double mapRange( const double &scale,
    const double &range )
  {
    return scale * range * 72;
  }
  void newpage();
  void newpath();
};

}

#endif // _POSTSCRIPT_H
